
// Copy and enable this next line to help with script debugging.
//    wizard.ReportError("If debugging is desired\n\n-Attach to Process\n-Script Debug\n-Hit Break All\n\nClick OK when Ready.");

// Set to the path where CxxTest is installed.
//var cxxTestPath = "C:\\Development\\CxxTest";

// This is the string used to call Python
var pythonPath = "C:/python34/python.exe"

// This is the install directory for CxxTest
var cxxTestPath = "C:/Development/CxxTest"

/*****************************************************************************/
// Based on the Generic C++ class wizard with Visual Studio 2008
function OnFinish(selProj, selObj)
{
   try
   {
      var strProjectPath = wizard.FindSymbol('PROJECT_PATH');
      var strProjectName = wizard.FindSymbol('PROJECT_NAME');
      var descriptionText = wizard.FindSymbol('DESCRIPTION_TEXT');

      // get the current date and add a symbol CURRENT_DATE
      var currentTime = new Date();
      var month       = currentTime.getMonth() + 1
      var day         = currentTime.getDate();
      var year        = currentTime.getFullYear();
      var today       = year + '.' + month + '.' + day;
      wizard.AddSymbol('CURRENT_DATE', today);
      wizard.AddSymbol('CURRENT_YEAR', year);
      // add symbols for the filters of the project
      wizard.AddSymbol('SOURCE_FOLDER_NAME',   'Source Files');
      wizard.AddSymbol('HEADER_FOLDER_NAME',   'Header Files');

      selProj = CreateCustomProject(strProjectName, strProjectPath);
      AddCommonConfig(selProj, strProjectName);
      AddConfig(selProj, strProjectName);
      AddFilters(selProj);

      var InfFile = CreateCustomInfFile();
		AddFilesToCustomProj(selProj, strProjectName, strProjectPath, InfFile);
      InfFile.Delete();

      selProj.Object.Save();
   }
   catch(e)
   {
      if (e.description.length != 0)
         SetErrorInfo(e);
      return e.number
   }
}

/*****************************************************************************/
function CreateCustomProject(strProjectName, strProjectPath)
{
	try
	{
		var strProjTemplatePath = wizard.FindSymbol('PROJECT_TEMPLATE_PATH');
		var strProjTemplate = '';
		var WizardVersion = wizard.FindSymbol('WIZARD_VERSION');
		if(WizardVersion >= 10.0)
			strProjTemplate = strProjTemplatePath + '\\default.vcxproj';
		else
			strProjTemplate = strProjTemplatePath + '\\default.vcproj';

		var Solution = dte.Solution;
		var strSolutionName = "";
		if (wizard.FindSymbol("CLOSE_SOLUTION"))
		{
			Solution.Close();
			strSolutionName = wizard.FindSymbol("VS_SOLUTION_NAME");
			if (strSolutionName.length)
			{
				var strSolutionPath = strProjectPath.substr(0, strProjectPath.length - strProjectName.length);
				Solution.Create(strSolutionPath, strSolutionName);
			}
		}

		var strProjectNameWithExt = '';
		if(WizardVersion >= 10.0)
			strProjectNameWithExt = strProjectName + '.vcxproj';
		else
			strProjectNameWithExt = strProjectName + '.vcproj';

		var oTarget = wizard.FindSymbol("TARGET");
		var prj;
		if (wizard.FindSymbol("WIZARD_TYPE") == vsWizardAddSubProject)  // vsWizardAddSubProject
		{
			var prjItem = oTarget.AddFromTemplate(strProjTemplate, strProjectNameWithExt);
			prj = prjItem.SubProject;
		}
		else
		{
			prj = oTarget.AddFromTemplate(strProjTemplate, strProjectPath, strProjectNameWithExt);
		}
		return prj;
	}
	catch(e)
	{
		throw e;
	}
}

/*****************************************************************************/
function AddFilters(proj)
{
   try
   {
	    // Add the folders to your project
      var group1 = proj.Object.AddFilter
                   (wizard.FindSymbol('SOURCE_FOLDER_NAME'));
      group1.Filter = "cpp;cxx;c;cc";

      var group2 = proj.Object.AddFilter
                   (wizard.FindSymbol('HEADER_FOLDER_NAME'));
      group2.Filter = "h;hpp;hh;inl";
   }
   catch(e)
   {
      throw e;
   }
} 

/*****************************************************************************/
function BuildCxxTestGenCmd(suiteName)
{
  var scriptGen   = pythonPath + " " + GetCxxTestDir() + "\\bin\\cxxtestgen";

  var suiteName     = wizard.FindSymbol('SUITE_NAME');
  var useExceptions = wizard.FindSymbol('USE_EXCEPTIONS');
  var useStdLib     = wizard.FindSymbol('USE_STD_LIB');
  var abortOnFail   = wizard.FindSymbol('ABORT_ON_FAIL');
  var noStaticInit  = wizard.FindSymbol('NO_STATIC_INIT');

  var cxxTestAuxCmd = "";
  
  if (useExceptions)
    cxxTestAuxCmd += "--have-eh ";

  if (useStdLib)
    cxxTestAuxCmd += "--have-std ";

  if (abortOnFail)
    cxxTestAuxCmd += "--abort-on-fail ";

  if (noStaticInit)
    cxxTestAuxCmd += "--no-static-init ";
    
  var command = scriptGen;
  command += ' --runner=ParenPrinter ';
  command += cxxTestAuxCmd;
  command += ' -o \"';
  command += suiteName;
  command += 'Runner.cpp\" \"../*.h\"\r\n';

  return command;
}

/*****************************************************************************/
function GetCxxTestDir()
{
  return cxxTestPath;
}

/*****************************************************************************/
function ConfigureInheritedProperties(config)
{
  var strCxxTestPropsPath;
  var strWizardPath   = wizard.FindSymbol('START_PATH');
  var WizardVersion   = wizard.FindSymbol('WIZARD_VERSION');
  var cxxTestVersion  = wizard.FindSymbol('CXXTEST_VERSION');

  if(WizardVersion >= 10.0)
  {
    // Until the proper method to add property files to VS2010,
    // The global path to CxxTest will be added to the project itself.

    // This is the proper command, however it is not supported for 
    // JavaScript in Visual Studio 2010.  
    // Until a proper workaround can be found, 
    // add the settings directly to the project.

    //if (3 == cxxTestVersion)
	  //  strCxxTestPropsPath = strWizardPath + '\\CxxTest_3.10.props;';
    //else
	  //  strCxxTestPropsPath = strWizardPath + '\\CxxTest_latest.props;';

     //config.AddPropertySheet(strCxxTestPropsPath);

    // Choose between version of v4.0 and v3.10.1
    var cxxTestDir = GetCxxTestDir();
    scriptGen = "python.exe " + cxxTestDir + "bin\\cxxtestgen\"";
  }
  else
  {
    strCxxTestPropsPath = strWizardPath + '\\CxxTest.vsprops;';

    config.InheritedPropertySheets = strCxxTestPropsPath;
  }
}

/*****************************************************************************/
function GetAdditionalIncludes()
{
  var srcRoot = wizard.FindSymbol('SRC_PATH');

  // VS2010 requires an additional path to be added to the 
  // Include paths because of a change in processing property files.
  // When property files can be associated with the wizard, 
  // this line can go away.
  var otherFiles = "";
  var WizardVersion = wizard.FindSymbol('WIZARD_VERSION');

  if(WizardVersion >= 10.0)
  {
    var cxxTestDir = GetCxxTestDir();

    // Add the CxxTest directory as an include directory for compiling.
    otherFiles = ';' + cxxTestDir;
  }

  var includes = './;' + srcRoot + otherFiles;

  return includes;
}

/*****************************************************************************/
function PopulateDebugConfig(proj, strProjectName)
{
   try
   {
      var useLocalOutput  = wizard.FindSymbol('USE_LOCAL_OUTPUT');
      var includes        = GetAdditionalIncludes();
      var cxxTestGenCmd   = BuildCxxTestGenCmd();  
  
      // ----------------------------------------------------------
      // settings for the DEBUG configuration
      // ----------------------------------------------------------
      var config = proj.Object.Configurations('Debug');

      // If use local output has been selected by the user, 
      // write their output files locally for Debug builds.
      if (useLocalOutput)
      {
        var localIntermedDir = wizard.FindSymbol('LOCAL_INTERMED_DIR');
        config.IntermediateDirectory = localIntermedDir + '$(ProjectName)\\Debug\\';
  
        var localOutputDir = wizard.FindSymbol('LOCAL_OUTPUT_DIR');
        config.OutputDirectory = localOutputDir + '$(ProjectName)\\Debug\\';
      }
      else
      {
        config.IntermediateDirectory = '.\\Debug\\';
        config.OutputDirectory = '.\\Debug\\';
      }

      ConfigureInheritedProperties(config);

      config.ConfigurationType = ConfigurationTypes.typeApplication;

      var CLTool = config.Tools('VCCLCompilerTool');
      CLTool.AdditionalIncludeDirectories = includes;
      CLTool.Detect64BitPortabilityProblems = false;
      CLTool.PreprocessorDefinitions = 'WIN32;_DEBUG;_CONSOLE';
      CLTool.UsePrecompiledHeader = pchOption.pchNone;
      CLTool.ObjectFile = '$(IntDir)\\';
      CLTool.ProgramDataBaseFileName = '$(IntDir)\\vc80.pdb';

      var LinkTool = config.Tools('VCLinkerTool');
      LinkTool.OutputFile = '$(OutDir)\\$(ProjectName).exe';
      LinkTool.GenerateManifest = true;
      LinkTool.ManifestFile = '$(IntDir)\\$(TargetFileName).intermediate.manifest';
      LinkTool.ProgramDatabaseFile = '.\\Debug/' + strProjectName + '.pdb';
      LinkTool.SubSystem = subSystemOption.subSystemConsole;

      var BrowseTool = config.Tools('VCBscMakeTool');
      BrowseTool.OutputFile = '$(OutDir)/' + strProjectName + '.bsc';

      // Add Script Generation command to run the runner generator      
      var PreBuildEventTool = config.Tools('VCPreBuildEventTool');
      PreBuildEventTool.CommandLine  =  'mkdir \"./Src/Generated\"\r\n';
      PreBuildEventTool.CommandLine +=  'cd \"./Src/Generated\"\r\n';
      PreBuildEventTool.CommandLine +=  cxxTestGenCmd;
      PreBuildEventTool.CommandLine +=  'cd \"../..\"';
      PreBuildEventTool.Description += 'Generate the test runner...\r\n';

      // Run the Unit test.
      var PostBuildEventTool = config.Tools('VCPostBuildEventTool');
      PostBuildEventTool.CommandLine = '\"$(OutDir)\\$(ProjectName).exe\"';
      PostBuildEventTool.Description += 'Perform test for ' + strProjectName;
   }
   catch(e)
   {
      throw e;
   }
}

/*****************************************************************************/
function PopulateReleaseConfig(proj, strProjectName)
{
   try
   {
      var includes        = GetAdditionalIncludes();
      var cxxTestGenCmd   = BuildCxxTestGenCmd();  
  
      // ----------------------------------------------------------
      // settings for the RELEASE configuration
      // ----------------------------------------------------------
      config = proj.Object.Configurations('Release');
      config.IntermediateDirectory = '.\\Release\\';
      config.OutputDirectory = '.\\Release\\';

      ConfigureInheritedProperties(config);

      config.ConfigurationType = ConfigurationTypes.typeApplication;

      var CLTool = config.Tools('VCCLCompilerTool');
      CLTool.AdditionalIncludeDirectories = './;' + srcRoot;
      CLTool.DebugInformationFormat = debugOption.debugDisabled;
      CLTool.Detect64BitPortabilityProblems = false;
      CLTool.InlineFunctionExpansion = expandOnlyInline;
      CLTool.WholeProgramOptimization = false;
      CLTool.PreprocessorDefinitions = 'WIN32;NDEBUG;_CONSOLE';
      CLTool.StringPooling = true;
      CLTool.EnableFunctionLevelLinking = true;
      CLTool.UsePrecompiledHeader = pchOption.pchNone;
      CLTool.ObjectFile = '$(IntDir)\\';
      CLTool.ProgramDataBaseFileName = '$(IntDir)\\vc80.pdb';

      var LinkTool = config.Tools('VCLinkerTool');
      LinkTool.OutputFile = '$(OutDir)\$(ProjectName).exe';
      LinkTool.GenerateManifest = true;
      LinkTool.ManifestFile = '$(IntDir)\$(TargetFileName).intermediate.manifest';
      LinkTool.SubSystem = subSystemOption.subSystemNotSet;
      LinkTool.OptimizeReferences = optRefType.optReferencesDefault;
      LinkTool.EnableCOMDATFolding = optFoldingType.optFoldingDefault;
      LinkTool.LinkTimeCodeGeneration = LinkTimeCodeGenerationOption.LinkTimeCodeGenerationOptionDefault;

      var BrowseTool = config.Tools('VCBscMakeTool');
      BrowseTool.OutputFile = '.\\Release/' + strProjectName + '.bsc';
         
      // Add Script Generation command to run the runner generator      
      var PreBuildEventTool = config.Tools('VCPreBuildEventTool');
      PreBuildEventTool.CommandLine  =  'mkdir \"./Src/Generated\"\r\n';
      PreBuildEventTool.CommandLine +=  'cd \"./Src/Generated\"\r\n';
      PreBuildEventTool.CommandLine +=  cxxTestGenCmd;
      PreBuildEventTool.CommandLine +=  'cd \"../..\"';

      PreBuildEventTool.Description += 'Generate the test runner...\r\n';

      // Run the Unit test.
      var PostBuildEventTool = config.Tools('VCPostBuildEventTool');
      PostBuildEventTool.CommandLine = '\"$(OutDir)\$(ProjectName).exe\"';
      PostBuildEventTool.Description += 'Perform test for ' + strProjectName;
   }
   catch(e)
   {
      throw e;
   }
}

/*****************************************************************************/
function AddConfig(proj, strProjectName)
{
  PopulateDebugConfig(proj, strProjectName);
  PopulateDebugConfig(proj, strProjectName);
}

/*****************************************************************************/
function DelFile(fso, strWizTempFile)
{
	try
	{
		if (fso.FileExists(strWizTempFile))
		{
			var tmpFile = fso.GetFile(strWizTempFile);
			tmpFile.Delete();
		}
	}
	catch(e)
	{
		throw e;
	}
}

/*****************************************************************************/
function CreateCustomInfFile()
{
	try
	{
		var fso, TemplatesFolder, TemplateFiles, strTemplate;
		fso = new ActiveXObject('Scripting.FileSystemObject');

		var TemporaryFolder = 2;
		var tfolder = fso.GetSpecialFolder(TemporaryFolder);
		var strTempFolder = tfolder.Drive + '\\' + tfolder.Name;

		var strWizTempFile = strTempFolder + "\\" + fso.GetTempName();

		var strTemplatePath = wizard.FindSymbol('TEMPLATES_PATH');
		var strInfFile = strTemplatePath + '\\Templates.inf';
		wizard.RenderTemplate(strInfFile, strWizTempFile);

		var WizTempFile = fso.GetFile(strWizTempFile);
		return WizTempFile;
	}
	catch(e)
	{
	  	wizard.ReportError(e.description);
		throw e;
	}
}

/*****************************************************************************/
function GetTargetName(strName)
{
   try
   {
      var strTarget = strName;
      // get the name of the class
      var strSuiteName = wizard.FindSymbol('SUITE_NAME');
      var srcRoot = wizard.FindSymbol('SRC_PATH');
      if ( strName == 'SampleTestSuite.h'
        || strName == 'SampleInlineTestSuite.h')
      {
         strTarget = srcRoot + '/' + strSuiteName + '.h';
      }
      else if (strName == 'SampleTestSuite.cpp')
      {
         strTarget = srcRoot + '/' + strSuiteName + '.cpp';
      }
      else if (strName == 'SampleTestSuiteRunner.cpp')
      {
         strTarget = srcRoot + '/Generated/' + strSuiteName + 'Runner.cpp';
      }

      return strTarget;
   }
   catch(e)
   {
      wizard.ReportError(e.description);
      throw e;
   }
}

/*****************************************************************************/
function KeepOutsideProject(strName)
{
   try
   {
      var add = false;

      if(strName == 'ReadMe.txt')
         add = true;
      if(strName == 'stdafx.h')
         add = true;

      return add;
   }
   catch(e)
   {
      throw e;
   }
}

/*****************************************************************************/
function AddFilesToCustomProj(proj, strProjectName, strProjectPath,
                              InfFile)
{
   try
   {
      var projItems = proj.ProjectItems

      // get references to the filters of the project
      var projFilters = proj.Object.Filters;
      var filterSrc =
         projFilters.Item(wizard.FindSymbol('SOURCE_FOLDER_NAME'));
      var filterHdr =
         projFilters.Item(wizard.FindSymbol('HEADER_FOLDER_NAME'));
      var strImpl = wizard.FindSymbol("IMPL_FILE");
      var isInline = wizard.FindSymbol("INLINE_IMPL");

      var strTemplatePath = wizard.FindSymbol('TEMPLATES_PATH');

      var strTpl  = '';
      var strName = '';

      var strTextStream = InfFile.OpenAsTextStream(1, -2);
      while (!strTextStream.AtEndOfStream)
      {
         strTpl = strTextStream.ReadLine();
         if (strTpl != '')
         {
            // Filter out the header based on the inline choice.
            if ( ( isInline
                && strTpl == 'SampleTestSuite.h')
              || ( !isInline
                && strTpl == 'SampleInlineTestSuite.h')
              || ( isInline
                && strTpl == 'SampleTestSuite.cpp'))
            {
              continue;
            }

         
            strName = strTpl;
            var strTarget = GetTargetName(strName);
            var strTemplate = strTemplatePath + '\\' + strTpl;
            var strFile = strProjectPath + '\\' + strTarget;

            var strExt = strName.substr(strName.lastIndexOf("."));
            wizard.RenderTemplate(strTemplate, strFile, false);

            if(!KeepOutsideProject(strName))
            {
               if ( strExt == '.cpp' 
                 || strExt == '.cxx' 
                 || strExt == '.c' 
                 || strExt == '.cc')
               {
                  filterSrc.AddFile(strTarget);
               }
               else if ( strExt == '.hpp' 
                      || strExt == '.h' 
                      || strExt == '.hh' 
                      || strExt == '.inl'
		      || strExt == '.hxx')
               {
                  filterHdr.AddFile(strTarget);
               }
               else
                  proj.Object.AddFile(strFile);
            }
         }
      }
      strTextStream.Close();
   }
   catch(e)
   {
      throw e;
  }
}

