
// Copy and enable this next line to help with script debugging.
//    wizard.ReportError("If debugging is desired\n\n-Attach to Process\n-Script Debug\n-Hit Break All\n\nClick OK when Ready.");

/*****************************************************************************/
// Based on the Generic C++ class wizard with Visual Studio 2008
function OnFinish(selProj, selObj)
{ 
  var oCM;
  try
  {
		oCM	= selProj.CodeModel;
    var strProjectPath = wizard.FindSymbol('PROJECT_PATH');
    var strProjectName = wizard.FindSymbol('PROJECT_NAME');
    var strFixtureName = wizard.FindSymbol('SUITE_NAME');
    var descriptionText = wizard.FindSymbol('DESCRIPTION_TEXT');

    // get the current date and add a symbol CURRENT_DATE
    var currentTime = new Date();
    var month       = currentTime.getMonth() + 1
    var day         = currentTime.getDate();
    var year        = currentTime.getFullYear();
    var today       = year + '.' + month + '.' + day;
    wizard.AddSymbol('CURRENT_DATE', today);
    wizard.AddSymbol('CURRENT_YEAR', year);
    // add symbols for the filters of the project
      wizard.AddSymbol('SOURCE_FOLDER_NAME',   'Source Files');
      wizard.AddSymbol('HEADER_FOLDER_NAME',   'Header Files');


		var strCxxTestFixture = "CxxTest::TestSuite";
		var strHeader = wizard.FindSymbol("HEADER_FILE");
		var strImpl = wizard.FindSymbol("IMPL_FILE");

		// The files we're adding the new class to might have arbitrary content. Make sure CM is synced up to the changes.
		oCM.Synchronize();

		bValid = wizard.ParentObject.ValidateMember(strFixtureName, vsCMElementClass);
		if (!bValid) {
			var L_ErrorMessageText = "Class '"+strFixtureName+"' is already implemented in the selected source file.";
			wizard.ReportError(L_ErrorMessageText);
			return;
		}

    var InfFile = CreateCustomInfFile();

		AddFilesToCustomProj(selProj, strProjectName, strProjectPath, InfFile);
    InfFile.Delete();

    selProj.Object.Save();
  }
  catch(e)
  {
    if (e.description.length != 0)
      SetErrorInfo(e);
    return e.number
  }
}

function CreateCustomInfFile()
{
	try
	{
		var fso, TemplatesFolder, TemplateFiles, strTemplate;
		fso = new ActiveXObject('Scripting.FileSystemObject');

		var TemporaryFolder = 2;
		var tfolder = fso.GetSpecialFolder(TemporaryFolder);
		var strTempFolder = tfolder.Drive + '\\' + tfolder.Name;

		var strWizTempFile = strTempFolder + "\\" + fso.GetTempName();

		var strTemplatePath = wizard.FindSymbol('TEMPLATES_PATH');
		var strInfFile = strTemplatePath + '\\Templates.inf';
		wizard.RenderTemplate(strInfFile, strWizTempFile);

		var WizTempFile = fso.GetFile(strWizTempFile);
		return WizTempFile;
	}
	catch(e)
	{
  	wizard.ReportError(e.description);
		throw e;
	}

}

function AddFilesToCustomProj(proj, strProjectName, strProjectPath,
                              InfFile)
{
  try
  {
    var projItems = proj.ProjectItems

      // get references to the filters of the project
      var projFilters = proj.Object.Filters;
    var filterSrc =
      projFilters.Item(wizard.FindSymbol('SOURCE_FOLDER_NAME'));
    var filterHdr =
      projFilters.Item(wizard.FindSymbol('HEADER_FOLDER_NAME'));
    var strImpl = wizard.FindSymbol("IMPL_FILE");
    var isInline = wizard.FindSymbol("INLINE_IMPL");


    var strTemplatePath = wizard.FindSymbol('TEMPLATES_PATH');

    var strTpl  = '';
    var strName = '';

    var strTextStream = InfFile.OpenAsTextStream(1, -2);
    while (!strTextStream.AtEndOfStream)
    {
      strTpl = strTextStream.ReadLine();
      if (strTpl != '')
      {
        // Filter out the header based on the inline choice.
        if ( ( isInline
          && strTpl == 'SampleTestFixture.h')
          || ( !isInline
          && strTpl == 'SampleInlineTestFixture.h'))
        {
          continue;
        }

        strName = strTpl;
        var strTarget = GetTargetName(strName);
        var strTemplate = strTemplatePath + '\\' + strTpl;
        var strFile = strProjectPath + '\\' + strTarget;

        var strExt = strName.substr(strName.lastIndexOf("."));
        wizard.RenderTemplate(strTemplate, strFile, false);

        if ( strExt == '.cpp' 
          || strExt == '.cxx' 
          || strExt == '.c' 
          || strExt == '.cc')
        {
          // Only add this file if the INLINE field is not checked.
          if (!isInline)
          {
            filterSrc.AddFile(strTarget);
          }
        }
        else if( strExt == '.hpp' 
              || strExt == '.h' 
              || strExt == '.hh'
              || strExt == '.inl'
              || strExt == '.hxx')
        {
          filterHdr.AddFile(strTarget);
        }
        else
          proj.Object.AddFile(strFile);
      }
    }
    strTextStream.Close();
  }
  catch(e)
  {
    wizard.ReportError(e.description);

    throw e;
  }
}

function GetTargetName(strName)
{
   try
   {
      var strTarget = strName;
      // get the name of the class
      var strSuiteName = wizard.FindSymbol('SUITE_NAME');
      var srcRoot = wizard.FindSymbol('SRC_PATH');

      if ( strName == 'SampleTestFixture.h'
        || strName == 'SampleInlineTestFixture.h')
      {
         strTarget = srcRoot + '/' + strSuiteName + '.h';
      }
      else if (strName == 'SampleTestFixture.cpp')
      {
         strTarget = srcRoot + '/' + strSuiteName + '.cpp';
      }

      return strTarget;
   }
   catch(e)
   {
      throw e;
   }
}

